﻿<!DOCTYPE html>
<html>
	<head>
		<title>Dashboard (SINGLE) - L2MAKER</title>
		<meta content="text/html; charset=utf-8" http-equiv="content-type">
		<!--[if IE]><base href="<% 
		String baseURL = request.getRequestURL().toString().replace("/l2s/dashboard/index.jsp", "/");
		out.print(baseURL); %>"></base><![endif]-->
		<!--[if !IE]>--><base href="../.." /><!--<![endif]-->
		<meta name="description" content="www.l2maker.com.br - Dashboard" />
		<meta name="keywords" content="L2S, L2MAKER, API Maker, Softwell Maker, dashboard"/>
		<link rel="icon" href="favicon.ico" type="image/x-icon" />

		<script type="text/javascript" src="l2s/dashboard/jquery-2.0.2.min.js"></script>
		<script type="text/javascript" src="l2s/dashboard/jquery-ui-1.10.3.min.js"></script>

		<script type="text/javascript" src="l2s/dashboard/dashboard.js.jsp"></script>
		<!-- Required D3 library -->
		<script src="//d3js.org/d3.v4.js"></script>

		<!-- D3Funnel source file -->
		<script src="l2s/dashboard/funnel/d3-funnel.dist.js"></script>
		
		<script type="text/javascript" src="l2s/commons/core.js"></script>
		<!-- GRAFICOS -->
		<script src="l2s/dashboard/chartjs-4/chart.umd.js"></script>
		<!-- -->
		<style type="text/css">
			html, body {
				margin: 0;
				padding: 0;
			}

			.layout {
				padding: 0px;
				margin: 0px;
			}

			.item-image {
				position: absolute;
				right: 4px;
				bottom: 4px;
			}
			
			.item-group-Graficos {
color: rgb(0, 0, 0);
    background: #EAEFF2 !important;
	border-bottom: 5px solid #17A6DE;
		
}

.chart-titulo {
	margin: auto;
}

.pie-legend li {
	display: inline-block;
	padding: 5px;
	font: 11px;
}

.pie-legend li span {
    width: 1em;
    height: 1em;
    display: inline-block;
    margin-right: 5px;
}
.pie-legend {
    list-style: none;  
	font-size: 10px;
}
		</style>
		<%
		String theme = request.getParameter("skin"); 
		if(theme == null || theme.equals("")) { 
			theme = "default"; 
		}
		%>
		<link rel="stylesheet" type="text/css" href="l2s/dashboard/themes/<%=theme%>/theme.css" />
		<link rel="stylesheet" type="text/css" href="l2s/dashboard/themes/<%=theme%>/jquery.ui.tooltip.css" />
	</head>
<body style="">
	<div id="single" class="layout" unselectable="on"
		onselectstart="return false;" style="overflow: hidden; height: <%=request.getParameter("height")%>px; width: <%=request.getParameter("width")%>px">
	</div>

<script type="text/javascript">
	$(function() {

		var onMouseEvent = getURLParam('onMouseEvent');
		var onDataRefresh = getURLParam('data');
		var chartType = getURLParam('chartType');
		var componentId = getURLParam('componentId');
		

		var dash = new Dashboard(componentId, '#single', chartType, onDataRefresh, onMouseEvent);
		window._dashboard = dash;
		document._dashboard = dash;
	});
</script>
<script type="text/javascript">
function Dashboard(componentId, divId, chartType, onDataRefresh, onMouseEvent) {
	this.div = $(divId);
	this.itens = new Array();
	this.onDataRefresh = onDataRefresh;
	this.onMouseEvent = onMouseEvent;
	this.chartType = chartType;
	this.componentId = componentId;
	
	this.startAutoRefresh();
}

Dashboard.prototype.addImage = function(id, titulo, imgSrc, descricao, grupo, tamanho) {
	var itemImg = false;
	var newItem = true;
	if(itemDiv) {
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDivCover = $(itemDiv).find('.cover');
		itemImg = $(itemDiv).find('.item-image');
		$(itemDivCover).find('.item-detail').remove();
		newItem = false;
		itemDiv.refreshValues(dados);
	} else {
		itemDiv = document.createElement('div');
		var groupID = 'item-group-' + grupo;
		var g = $('#' + groupID)[0];
		if(g) {
			var _cssRules = g._cssRules;
			if(_cssRules) {
				itemDiv.style = ' ' + _cssRules;
			}
		}
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDiv.id = itemID;
		itemDiv.draggable = 'true';
		itemDiv.setAttribute('codigo', id);
		itemDiv.addEventListener('click', function(event) { window._dashboard.fireMouseAction(id, -1, 'CLICK', event); });
		itemDiv.addEventListener('dblclick', function(event) { window._dashboard.fireMouseAction(id, -1, 'DBLCLICK', event); });
		//itemDiv.addEventListener('dragover', function(event) { event.preventDefault(); });
		itemDiv.addEventListener('drop', function(event) {
				var data = event.dataTransfer.getData("text/plain")
				window._dashboard.fireDropAction(id, data, event); 
			});
		itemDiv.addEventListener('dragstart', function(ev) {
			ev.dataTransfer.setData("text", id);
		});

		
		var itemHead = document.createElement('h3');
		itemHead.className = 'item-head';
		itemHead.innerText = titulo;
		itemHead.style.fontSize = '16px';
		itemHead.style.height = '20px';
		itemDiv.appendChild(itemHead);

		itemImg = document.createElement('img');

		itemImg.className = 'item-image';
		itemDiv.appendChild(itemImg);
		itemImg.style.width = '95%';
		itemImg.style.height = 'calc(100% - 20px)';
		if(imgSrc) {
			itemImg.src = imgSrc;
			itemImg.style.display = 'block';
		} else {
			itemImg.style.display = 'none';
		}
	}

	if(descricao) {
		itemImg.alt = descricao;
	}

	this.div.append(itemDiv);
}

Dashboard.prototype.addChart = function(grafico, titulo, dados, grupo, tamanho, descricao) {
	if(grafico == 'FUNIL') {
		this.setFunil(this.div, dados, titulo);
	} else if(grafico == 'BARRAS') {
		this.setChartBars(this.div, dados, titulo);
	} else if(grafico == 'PIZZA') {
		this.setChartPie(this.div, dados, titulo);
	} else if(grafico == 'LINHAS') {
		this.setChartLines(this.div, dados, titulo);
	} else {
		var itemFrame = document.createElement('iframe');
		itemFrame.className = 'item-frame';
		itemFrame.style.width = '100%';
		itemFrame.style.height = '100%';
		itemFrame.style.border = '0px';
		itemFrame.style.overflow = "hidden";
		this.div.appendChild(itemFrame);
		var label = '';
		if(!dados) {
			dados = {minValue: 0, maxValue: 0, value: 0};
		}
		var minValue = dados.minValue ? dados.minValue : 0;
		var maxValue = dados.maxValue ? dados.maxValue : 100;
		var currValue = dados.value ? dados.value : 0;
		itemFrame.src = 'l2s/charts/simpleGauge2.jsp?title=' + encodeURIComponent(titulo) + '&label=' + label + '&minValue=' + minValue +'&maxValue=' + maxValue + '&currValue=' + currValue +'&';
		this.div.itemFrame = itemFrame;

		this.div.refreshValues = function(values) {
			itemFrame.contentDocument.refreshValues(values ? values.value : 0);
		}
	}

	if(descricao) {
		this.div.title = descricao;
		$( this.div ).tooltip({
				content: descricao,
				track: false
		});
	}
}

Dashboard.prototype.setChartBars = function(itemDiv, dados, titulo) {debugger;
	var serieData = toChartData(dados, titulo);
	var divGBarras = document.createElement('canvas');
	divGBarras.id = "canvas" + itemDiv.id;
	itemDiv.append(divGBarras);
	var graficoBarras = false;
	setTimeout(function() {
		var ctx = divGBarras.getContext("2d");
		graficoBarras = new Chart(ctx, {
			type: 'bar',
			data: serieData,
			options: {
				responsive: true,
				maintainAspectRatio: false,
				legend: {
					display: false
				}
			}
		});
	}, 500);
	itemDiv.refreshValues = function(values) {
			
			graficoBarras.data = toChartData(values, titulo);
			if(graficoBarras.update) {
				graficoBarras.update();
			}
		}
}

Dashboard.prototype.setChartLines = function(itemDiv, dados, titulo) {
	var graficoLinhas = false;
	var serieData = toChartData(dados, titulo);
	serieData.datasets[0].backgroundColor = "rgba(151,187,205,0.5)";
	serieData.datasets[0].borderColor = "rgba(151,187,205,0.8)";

	var divGBarras = document.createElement('canvas');
	divGBarras.id = "canvas-linhas-" + itemDiv.id;
	itemDiv.append(divGBarras);
	setTimeout(function() {
		var ctx = divGBarras.getContext("2d");
		graficoLinhas = new Chart(ctx, {
			type: 'line',
			data: serieData,
			options: {
				responsive: true,
				maintainAspectRatio: false,
				legend: {
					display: false
				}
			}
		});
	}, 500);
	itemDiv.refreshValues = function(values) {
			var serieData = toChartData(dados, titulo);
			serieData.datasets[0].backgroundColor = "rgba(151,187,205,0.5)";
			serieData.datasets[0].borderColor = "rgba(151,187,205,0.8)";
			graficoLinhas.data = serieData;
			if(graficoLinhas.update) {
				graficoLinhas.update();
			}
		}
}

Dashboard.prototype.setChartPie = function(itemDiv, dados, titulo) {
	var serieData = toChartData(dados, titulo);
	var divChart = document.createElement('canvas');
	divChart.id = "canvas" + itemDiv.id;
	itemDiv.append(divChart);
	var graficoPizza = false;
	setTimeout(function() {
		var ctx = divChart.getContext("2d");
		graficoPizza = new Chart(ctx, {
			type: 'pie',
			data: serieData,
			options: {
			responsive: true,
			maintainAspectRatio: true,
			legendTemplate : "<ul class=\"<" + "%=name.toLowerCase()%" + ">-legend\"><" + "% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<" + "%=segments[i].fillColor%"+">\"></span><" + "%if(segments[i].label){%" + "><" + "%=segments[i].label%" + "><" + "%}%" + "></li><" + "%}%" + "></ul>",
			legendTemplate: "<ul class=\"<" + "%=name.toLowerCase()%" + ">-legend\"><" + "% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<" + "%=segments[i].fillColor%"+">\"></span><" + "%if(segments[i].label){%" + "><" + "%=segments[i].label%" + "><" + "%}%" + "></li><" + "%}%" + "></ul>"
			}
		});
	}, 500);
	itemDiv.refreshValues = function(values) {
		if(graficoPizza._old_Values && (graficoPizza._old_Values == JSON.stringify(values))) {
			return;//Ignora igual
		}
		graficoPizza._old_Values = JSON.stringify(values);

		var serieData = toChartData(values, titulo);
		graficoPizza.data = serieData;
		if(graficoPizza.update) {
			graficoPizza.update('active');
		}
	}
}

Dashboard.prototype.setFunil = function(itemDiv, dados, titulo) {
	const FUNNEL_OPTS = {
			chart: {
				bottomPinch: 1,
				curve: {
					enabled: true,
				},
				bottomWidth: 1 / 3,
			},
			block: {
				dynamicHeight: false,
			},
			animate: 200,
		};

	itemDiv._funnel = false;
	//
	setTimeout(function() {
		const chart = new D3Funnel('#single');
		chart.draw(dados, FUNNEL_OPTS);
		itemDiv._funnel = chart;
	}, 2);

	itemDiv.refreshValues = function(values) {
		itemDiv._funnel.draw(values, FUNNEL_OPTS)
	}
}

Dashboard.prototype.refresh = function() {
	if(this.onDataRefresh) {
		try {
			var resposta;
			if(typeof this.onDataRefresh == 'string') {
				if(this.onDataRefresh) {
					if(this.onDataRefresh[0] == '{') {
						resposta = this.onDataRefresh;//Dados fixos
					} else {
						resposta = callFlow(this.onDataRefresh, [ this.componentId ]);
					}
				} else {
					alert('Dados não informados.');
				}
			} else {
				//Object
				resposta = this.onDataRefresh;
			}

			if(!resposta) return false;
			var item = eval('(' + resposta + ')');
			try {
				if(this.div.refreshValues) {
					this.div.refreshValues(item.dados);
					return;
				}
				if(this.chartType == 'IMAGEM') {
					this.addImage(item.titulo, item.url, item.descricao, item.grupo, item.tamanho);
				} else {
					this.addChart(this.chartType, item.titulo, item.dados, item.grupo, item.tamanho, item.descricao);
				}
			} catch (e) {
				console.log(e);
			}
		} catch (e) {
			throw e;
		}
	}  
}

Dashboard.prototype.startAutoRefresh = function(refreshInterval, refreshAll) {
	var dash = this;
	setTimeout(function() { dash.refresh(); }, 100);
}

Dashboard.prototype.fireMouseAction = function(id, item, acao, event) {
	console.log(acao);
	if(this.onMouseEvent) {
		try {
			var x = mouseX(event);
			var y = mouseY(event);
			var resposta = callFlow(this.onMouseEvent, [id, item, acao, x, y]);
			if(event) {
				event.stopPropagation();
			}
			return true;
		} catch (e) {
			alert(e);
		}
	}
	if(event) {
		event.stopPropagation();
	}
	return false;
}

</script>
</body>
</html>